/*
 *     Copyright: Eugene M. Hutorny (c) 2009, eugene@hutorny.in.ua
 *     License:   Licensed to public under The GNU Lesser General Public License (LGPLv3) 
 *                http://www.opensource.org/licenses/lgpl-3.0.html
 */
package ua.in.hutorny.otj.exer1;

import ua.in.hutorny.otj.exer1.money.Cash;
import ua.in.hutorny.otj.exer1.money.Currency;
import ua.in.hutorny.otj.exer1.money.Treasury;
import ua.in.hutorny.otj.exer1.exeptions.ForgotMyWalletException;
import ua.in.hutorny.otj.exer1.exeptions.NotEnoughCash;

public class Person {
	public final String name; 
	public Person(String name) {
		super();
		this.name = name;
	}
	
	/**
	 *	Wallet cannot escape the person it belongs to
	 *  Although, it may be given to another person :-) 
	 */
	protected final class Wallet extends Treasury {
		
	}
	/**
	 * For simplicity, assume that a person may hold one wallet only
	 */
	private Wallet wallet = new Wallet();
	
	protected Person.Wallet wallet() {
		return wallet;
	}
	
	public Cash gives(double amount, Currency currency) throws NotEnoughCash {
		if( null == wallet )
			throw new ForgotMyWalletException();	// :-)
		return wallet.get(amount, currency);
	}

	public void takes(Cash cash) {
		if( null == wallet ) {
			wallet = new Wallet();
		}
		wallet.put(cash);
	}
	
	public String toString() {
		return getClass().getSimpleName() + "("+ name +  ")." + wallet.toString();
	}
}
