/*
 *     Copyright: Eugene M. Hutorny (c) 2009, eugene@hutorny.in.ua
 *     License:   Licensed to public under The GNU Lesser General Public License (LGPLv3) 
 *                http://www.opensource.org/licenses/lgpl-3.0.html
 */
package ua.in.hutorny.otj.exer1.bank;

import java.math.BigDecimal;

import ua.in.hutorny.otj.exer1.Person;
import base ua.in.hutorny.otj.exer1.accounting.Account;
import ua.in.hutorny.otj.exer1.accounting.WithdrawCollaboration;
import ua.in.hutorny.otj.exer1.exeptions.NotEnoughCash;
import ua.in.hutorny.otj.exer1.exeptions.NotEnoughFunds;
import ua.in.hutorny.otj.exer1.money.Cash;
import ua.in.hutorny.otj.exer1.money.Currency;

team abstract class BankCollaboration extends WithdrawCollaboration {
	protected BankCollaboration(Bank bank, Bank.BankAccount account, double interest) {
		super();
		this.bank = bank;
		this.interest = interest;
		this.account = account;
	}

	@Override
	protected BigDecimal calculateFee(BigDecimal amount) {
		return new BigDecimal(amount.doubleValue() * interest);
	}
	protected class CurrencyConverter playedBy Bank {
		BigDecimal convert(Currency from, Currency to, BigDecimal amount) -> 
			BigDecimal internalConversion(Currency from, BigDecimal amount)
			with { from -> from, amount -> amount, result <- result }
	}
		
	protected class CreditAccount playedBy Bank.BankAccount {
		@SuppressWarnings("decapsulation")
		credit -> credit;
		currency -> currency;
	}
	
	protected class OperationalAccount playedBy Account {
		@SuppressWarnings("decapsulation")
		debit -> debit;
		currency -> currency;		
	}
	protected class Operator playedBy Bank {
		OperationalAccount operationalAccount() -> Account operationalAccount();		
	}
	protected final Bank bank;
	protected final Bank.BankAccount account;
	protected final double interest;
}
