/*
 *     Copyright: Eugene M. Hutorny (c) 2009, eugene@hutorny.in.ua
 *     License:   Licensed to public under The GNU Lesser General Public License (LGPLv3) 
 *                http://www.opensource.org/licenses/lgpl-3.0.html
 */
package ua.in.hutorny.otj.exer1.bank;

import java.math.BigDecimal;

import ua.in.hutorny.otj.exer1.Person;
import ua.in.hutorny.otj.exer1.accounting.Account;
import ua.in.hutorny.otj.exer1.exeptions.NotEnoughCash;
import ua.in.hutorny.otj.exer1.exeptions.NotEnoughFunds;
import ua.in.hutorny.otj.exer1.money.Cash;
import ua.in.hutorny.otj.exer1.money.Currency;

team class GetCashFromBankCollaboration2 extends BankCollaboration implements Cashier {
	protected GetCashFromBankCollaboration2(Bank bank, Bank.BankAccount account, double interest) {
		super(bank, account, interest);
	}

	@SuppressWarnings("bindingconventions") // if person is imported as 'base' class, it is not recognized as a regular class 
	protected class CashRecipient extends DebitAccount playedBy Person {

		void takes(Cash cash) -> void takes(Cash cash);

		protected void debit(BigDecimal amount, Currency currency) {
			assert reserved.value() == amount && reserved.currency() == currency; 
			takes(reserved);			
		}
	}
	
	
	public void giveCashTo(Person person, double amount) throws NotEnoughFunds, NotEnoughCash {
		BigDecimal value = new BigDecimal(amount);
		reserved = bank.acquireCash(value, account.currency());
		try {
			cashOperation(new BigDecimal(amount), account, person, bank, bank);
		}
		finally {
			if( reserved.value().signum() != 0 ) {
			// Recipient did not take the money
				bank.returnCash(reserved);
			}
		}
	} 
	
	protected void cashOperation(BigDecimal amount, Bank.BankAccount as CreditAccount creditAccount, Person as CashRecipient cashRecipient, 
			Bank as Operator operator, Bank as CurrencyConverter currencyConverter) throws NotEnoughFunds {		
		withdrawCash(amount, creditAccount, cashRecipient, operator.operationalAccount(), currencyConverter);
	}
	
	protected void withdrawCash(BigDecimal amount, CreditAccount creditAccount, DebitAccount cashRecipient, 
			Account as OperationalAccount operationalAccount, CurrencyConverter currencyConverter) throws NotEnoughFunds {
		withdraw(amount, creditAccount, cashRecipient, operationalAccount, currencyConverter);
	}
	
	private Cash reserved;
}
